<?
function ng_gallery_geo_include($out, $picturelist){ 

// Auslesen der Galerieinformationen (werden aus erstem Bild übernommen)
foreach ($picturelist as $gallerydata) 
{
	$gallery_id = $gallerydata->gid;
	$gallery_title = $gallerydata->title;
	$gallery_path = $gallerydata->path;
	$gallery_previewpic = $gallerydata->previewpic;
	$gallery_galdesc = $gallerydata->galdesc;
	break;
}

// Abrufen des Zoomlevels
$ngg_geo_map_zoomlevel = get_option('ngg_geo_zoom_level');

// Die Variable $ngg_geo_pass zählt mit, wie oft das script durchlaufen wurde. Damit werden später die Karten nummeriert
if (!isset ($ngg_geo_pass)) {static $ngg_geo_pass = 1;}

// Zum Auslesen der Infos geht die Schleife los.
$control = 0;

foreach ($picturelist as $picture_data) 
		{
			
		$picture = $picture_data->filename;
		$picture_path = $gallery_path."/".$picture;
		$picture_thumbs_path = $gallery_path."/thumbs/thumbs_".$picture;
		
		
		// Scheinbar gibt es Probleme, wenn Bilder mit Photoshop bearbeitet wurden. Es wird dann eine Warnung ausgegeben, diese stellt man besser aus
		error_reporting(0);
		
		
		// Es muss erst geprüft werden, ob überhaupt GPS Daten fuer das Bild gespeichert sind, die Daten werden abgerufen
		if ($coordinates = ng_gallery_geo_coordinates($picture_path)) 
			{


					// Verpackt ist es nun. Jetzt folgt die Ausgabe in die Karte.
					// $control_1 wird genutzt, um die Bilder sinnvoll zu nummerieren. $control_1 kann außerdem genutzt werden, um festzustellen, welche Fotos der Galerie über Geo-Informationen verfügen bzw. auf der Karte angezeigt werden. Dazu wird die Variable wieder um eins verringert
					$control_1 = ($control + 1);
					
					// Die Pin-Beschreibung wird zusammengebaut: Ist eine Bildbeschreibung vorhanden? Falls nicht, wird die Nummer und die Galerie angegeben
					if ((strlen($picture_data->description)) > 1) {$pin_description = '<b>'.$picture_data->description.'</b><br><br><img src="'.$picture_thumbs_path.'" alt="foto" /><br><br>'.__('GPS coordinates', 'nextgen-gallery-geo').' <br> '.__('latitude:', 'nextgen-gallery-geo').' '.$coordinates[gps_breite_format].'<br> '.__('longitude:', 'nextgen-gallery-geo').' '.$coordinates[gps_laenge_format].'';}
					else {$pin_description = sprintf(__('<b>Photo Nr. %1$s of gallery %2$s</b><br><br><img src="%3$s" alt="foto" /><br><br>GPS coordinates <br> Latitude: %4$s<br> Longitude: %5$s', 'nextgen-gallery-geo'), $control_1, $gallery_title, $picture_thumbs_path, $coordinates[gps_breite_format], $coordinates[gps_laenge_format]);}
					
					// Falls die Schleife zum ersten Mal durchläuft, muss erst die Karte erstellt werden und der div Container eingefügt werden
							if (!isset($ngg_geo_init))
							{
								$ngg_geo_init = 1;
								$ngg_geo_return = '<br style="clear:both" /><br><div id="ngg_geo_map_'.$ngg_geo_pass.'" class="ngg_geo_map"></div>
								<script type="text/javascript">
										 var map = null;
										 
										 function nggGeoMap()
										 {
											map_'.$ngg_geo_pass.' = new VEMap("ngg_geo_map_'.$ngg_geo_pass.'");
											map_'.$ngg_geo_pass.'.SetCredentials("Your Bing Maps Key");
											map_'.$ngg_geo_pass.'.HideDashboard();
											map_'.$ngg_geo_pass.'.LoadMap();
											map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.'.get_option("ngg_geo_map_type").');
											var locs = [];
								';	
							}
					
					
					// $ngg_geo_map_pins zählt mit, wie viele pins gesetzt wurden. Dies dient u.a. zur sinnvollen Benennung
					if (!isset ($ngg_geo_map_pins)) {$ngg_geo_map_pins = 0;}
					$ngg_geo_map_pins++;
					
					
					// Die eigentliche Schleife beginnt
					$ngg_geo_return .= 
					
								'var loc_'.$ngg_geo_map_pins.' = new VELatLong('.$coordinates[gps_breite].','.$coordinates[gps_laenge].');
								var pin_'.$ngg_geo_map_pins.' = new VEPushpin('.$ngg_geo_map_pins.', loc_'.$ngg_geo_map_pins.', "wp-content/plugins/nextgen-gallery-geo/thumbnail.php?src='.urlencode($picture_data->thumbURL).'&p=40", "'.$gallery_title.'", \''.$pin_description.'\');            
								map_'.$ngg_geo_pass.'.AddPushpin(pin_'.$ngg_geo_map_pins.');
								locs.push(loc_'.$ngg_geo_map_pins.');';
					
					
					// Es gibt also Punkte auf der Karte. Also kann das Ganze angezeigt werden.
					$on = 2;
					}
		
		$control++;
		}

// Die Karte wird geschlossen, der Fokus gesetzt und die Karte eingebunden
if ($on == 2) {
				
					/// Soll eine Reiseroute dargestellt werden? Falls ja, wird entsprechend eine Linie eingeblendet
					if (get_option('ngg_geo_map_route') == 1) {$ngg_geo_return .= 'var routeColor = new VEColor(0,0,255,.2); var poly = new VEPolyline(12, locs, routeColor, 5); map_'.$ngg_geo_pass.'.AddPolyline(poly);';}
					
					// Ist mehr als ein pin vorhanden? Falls ja, erfolgt die Fokussierung automatisch. Andernfalls wird auf den einzigen pin fokussiert, und ein definiertes zoomlevel verwendet
					if ($ngg_geo_map_pins == 1) 
						{$ngg_geo_return .= 'map_'.$ngg_geo_pass.'.SetCenterAndZoom(loc_1, '.$ngg_geo_map_zoomlevel.')';
												// Soll Birdseyeview eingebunden werden, falls vorhanden?
												if  (get_option('ngg_geo_map_bev') == 1) 
												{
													$ngg_geo_return .= 
													'
													map_'.$ngg_geo_pass.'.AttachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');
														  function OnObliqueEnterHandler_'.$ngg_geo_pass.'()
																{	if (map_'.$ngg_geo_pass.'.IsBirdseyeAvailable())
																	{  map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.Birdseye);
																	 map_'.$ngg_geo_pass.'.DetachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');	}
																}
																';
												}
						}
					else {$ngg_geo_return .= 'map_'.$ngg_geo_pass.'.SetMapView(locs);';}
					
					// Die Karte wird geschlossen und aufgerufen
				  	$ngg_geo_return .= '} </script><script type="text/javascript"> nggGeoMap(); </script>';
			 }







###########################################################
##### Keine Geodaten vorhanden, geocoding (falls erwünscht)
###########################################################



if (!isset ($on) and get_option('ngg_geo_geocoding_provider') != "no")
{
	// Galeriename in Geocode umwandeln
	$ngg_geo_geocode_data = ngg_geo_geocode($gallery_title);
	
		if ($ngg_geo_geocode_data != "error")
	{
		$control = 1;
	
// Ist ein Vorschaubild vorhanden? Falls ja, wird dieses als Icon verwendet. Falls nein, wird das erste Bild als Icon verwendet.
if ($gallery_previewpic != 0)	{$map_previewpic_path = $picturelist[$gallery_previewpic]->thumbnailURL;}
else 							{foreach ($picturelist as $gallerydata) {$map_previewpic_path = $gallerydata->thumbURL; break;}}
							

	
	// Ist eine Galeriebeschreibung vorhanden? Falls ja, wird diese ausgegeben.
	if ($gallery_galdesc != "") 
	{
				$map_description = "<b>".$gallery_galdesc."</b><br><br><img src=\"".$map_previewpic_path."\" alt=\"foto\" />";
				// Vorher muessen noch alle Zeilenumbrueche entfrent werden
				$map_description = preg_replace("/\r|\n/s", "", $map_description);
	}
	else {$map_description = sprintf(__('<b>Photo of gallery "%1$s" </b><br><br><img src="%2$s" alt="photo" />', 'nextgen-gallery-geo'), $gallery_title, $map_previewpic_path);}
	
	
	



$ngg_geo_return = '<br style="clear:both" /><div id="ngg_geo_map_'.$ngg_geo_pass.'" class="ngg_geo_map"></div>';
$ngg_geo_return .=
'
   <script type="text/javascript">
         var map_'.$ngg_geo_pass.' = null;
         
         function nggGeoMap()
         {
            map_'.$ngg_geo_pass.' = new VEMap("ngg_geo_map_'.$ngg_geo_pass.'");
            map_'.$ngg_geo_pass.'.SetCredentials("Your Bing Maps Key");
   			map_'.$ngg_geo_pass.'.HideDashboard();
			map_'.$ngg_geo_pass.'.LoadMap();
			var x = new VELatLong('.$ngg_geo_geocode_data.');
			map_'.$ngg_geo_pass.'.SetCenterAndZoom(x, '.$ngg_geo_map_zoomlevel.');
			map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.'.get_option("ngg_geo_map_type").');
						
			var pin = new VEPushpin(1, map_'.$ngg_geo_pass.'.GetCenter(), "'.$map_previewpic_path.'", "'.$gallery_title.'", \''.$map_description.'\');            
			map_'.$ngg_geo_pass.'.AddPushpin(pin);';
			

					// Soll Birdseyeview eingebunden werden, falls vorhanden?
			        if  (get_option('ngg_geo_map_bev') == 1) 
					{
						$ngg_geo_return .= 
						'
		 				map_'.$ngg_geo_pass.'.AttachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');
		        			  function OnObliqueEnterHandler_'.$ngg_geo_pass.'()
								 	{	if (map_'.$ngg_geo_pass.'.IsBirdseyeAvailable())
										{  map_'.$ngg_geo_pass.'.SetMapStyle(VEMapStyle.Birdseye);
							  			 map_'.$ngg_geo_pass.'.DetachEvent("onobliqueenter", OnObliqueEnterHandler_'.$ngg_geo_pass.');	}
									}
									';
					}
					
					
$ngg_geo_return .=
'}
nggGeoMap();
</script>';


		$on = 1;

		
	}
	
}

// Fehlermeldung: Es konnte keine Karte erstellt werden. Diese Meldung kann deaktiviert werden
if (!isset ($on) && get_option('ngg_geo_error') == 1) {_e('error: unable to generate map', 'nextgen-gallery-geo');}


// Der Durchlaufszähler wird als statische Variable erhoeht, damit die mapstraction Karten sinnvoll benannt werden koennen
$ngg_geo_pass++;

$out .= $ngg_geo_return;
return $out;
}
?>